import expyriment

n_trials = 2
n_blocks = 2
fast_stimuli = ["cruel", "love"]
instructions = "Will present two kind of word. Press SPACE if the positive word presented. \n \
                and do NOT press anything if the negative one. \
                \n if you are ready press ENTER."

expyriment.io.defaults.outputfile_time_stamp = False
experiment = expyriment.design.Experiment(name="Go/NoGO")
expyriment.control.initialize(experiment)
# expyriment.io.Mouse(show_cursor=True)
# s1 = expyriment.stimuli.Audio('ans_er.wav')
# s1.preload()

# begin loop stimulus and blocks
for block in range(n_blocks):
    b = expyriment.design.Block(name=str(block + 1))
    for trial in range(n_trials):
        my_stim = fast_stimuli[trial]
        t_stim = expyriment.stimuli.TextLine(text=my_stim, text_size=40)
        t_trial = expyriment.design.Trial()
        t_trial.add_stimulus(t_stim)
##        if gonogo_stimuli[trial] == 'cruel':
##            correct = None
##        elif gonogo_stimuli[trial] == 'mean':
##            correct = None
##        elif gonogo_stimuli[trial] == 'kill':
##            correct = None
##        elif gonogo_stimuli[trial] == 'patient':
##            correct = 32
##        elif gonogo_stimuli[trial] == 'tolerance':
##            correct = 32
##        elif gonogo_stimuli[trial] == 'cool':
##            correct = 32
##        elif gonogo_stimuli[trial] == 'wise':
##            correct = 32
##        elif gonogo_stimuli[trial] == 'rape':
##            correct = None
##        elif gonogo_stimuli[trial] == 'mutilation':
##            correct = 0
##        else:
##            correct = 32
##        t_trial.set_factor("correct", correct)
        b.add_trial(t_trial)
    b.shuffle_trials()
    experiment.add_block(b)

experiment.data_variable_names = ["block", "keypres","trial_id",
                                  "RT", "answer"]
expyriment.control.start()
fixation_cross = expyriment.stimuli.FixCross()
fixation_cross.preload()
expyriment.stimuli.TextScreen("Go/NoGo Task", instructions).present()
experiment.keyboard.wait(expyriment.misc.constants.K_KP_ENTER)

for block in experiment.blocks:
    for trial in block.trials:
        trial.stimuli[0].preload()
        fixation_cross.present()
        experiment.clock.wait(500)
        trial.stimuli[0].present()
        experiment.clock.reset_stopwatch()
        key, rt= experiment.keyboard.wait(expyriment.misc.constants.K_SPACE,
                                          duration = 500)
##        if fast_stimuli[0] == 'cruel':
##            if key is None:
##                score = -1
##            else:
##                score = 2
##        if fast_stimuli[1] == 'love':
##            if key == expyriment.misc.constants.K_SPACE:
##                score = 1
##            else:
##                score = -2
        if key is None:  #  Not responded
            if fast_stimuli == "cruel":
                correct = 1 # true reject
            else:
                correct = -1 # false hit
        else:
            if fast_stimuli == "love" and key == expyriment.misc.constants.K_SPACE:
                correct = 2 # hit
            else:
                correct = -2 # false reject

        #if key != expyriment.misc.constants.K_SPACE and fast_stimuli[0] == 'cruel': # not responded
        #   score = 2 # true reject
        #else:
        #    score = -1 # false hit
            # int(0 if key is None else None)
            #if key == expyriment.misc.constants.K_SPACE:
        #if key == expyriment.misc.constants.K_SPACE and fast_stimuli[1] == 'love':
        #    score = 1 # hit
        #else:
        #    score = -2 # false reject
      
        experiment.data.add([block.name, key, trial.id, rt, correct])# raise error  AttributeError: 'NoneType' object has no attribute 'add'
                                                                 # Exception TypeError: "'NoneType' object is not callable" in
                                                                 # <bound method _LaminaPanelSurface.__del__ of <expyriment.stimuli._visual._LaminaPanelSurface objectat 0x07FA1F30>> ignored


    if block.name != "2":
        expyriment.stimuli.TextScreen("Break", "That was block: " 
                                        + block.name + 
                                        ". \n The next block begin ",
                                        ).present()
        experiment.clock.wait(3000)
    else:
        expyriment.stimuli.TextScreen("End of Stimuli", "That was block: "
                                      + block.name).present()
        experiment.clock.wait(3000)

# End
expyriment.control.end(goodbye_text="Thanks for the contribution",
             goodbye_delay=2000)
